#include "CWindow.h"    // NX`wb_
#include <d3d9.h>
#include <d3dx9.h>


#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")
#pragma comment(lib, "dxguid.lib")

// _\
typedef struct _D3DTLVERTEX {
	float	x,y,z;									// _XYZW
	float	rhw;									// `掞XYZ犄鐔ibȂ̂ł͏1ƂȂƊo悤j
	DWORD	color;									// _̐F(32bitAt@l)
	float	tu, tv;									// _Ɋ蓖ĂeNX`UVl
} D3DTLVERTEX, *LPD3DTLVERTEX;

// _̏
#define D3DFVF_TLVERTEX		(D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_TEX1)

// Direct3DIuWFNg|C^
LPDIRECT3D9				lpD3D		= NULL;			// Direct3D
LPDIRECT3DDEVICE9		lpD3DDevice	= NULL;			// Direct3DDevice
LPDIRECT3DTEXTURE9		lpTex		= NULL;			// Direct3DTexture

// _f[^
D3DTLVERTEX				v[4];						// lp4_
D3DTLVERTEX				v2[4];						// wip4_


int WINAPI WinMain( HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpszCmdParam,int nCmdShow )
{
    CWindow win;
    if( !win.Create(hInstance,L"TestD3D9 -effect-") )
        return -1;

	// Direct3DIuWFNg̎擾
	lpD3D = Direct3DCreate9( D3D_SDK_VERSION );
	if( !lpD3D ) {
		MessageBoxW( win.hWnd,L"Direct3D쐬o܂ł",L"G[ɂ",MB_OK|MB_ICONHAND );
		return -1;
	}

	// Direct3DfoCX̐ݒZbg
	D3DPRESENT_PARAMETERS param;
	ZeroMemory( &param,sizeof(param) );
	param.Windowed						= TRUE;								// EBhE[h
	param.SwapEffect					= D3DSWAPEFFECT_DISCARD;			// Ńtbv
	param.BackBufferCount				= 1;								// obNobt@̐
	param.BackBufferWidth				= 640;								// ʂ̕
	param.BackBufferHeight				= 480;								// ʂ̍
	param.FullScreen_RefreshRateInHz	= 0;								// tbV[g(0=ftHggp)
	param.EnableAutoDepthStencil		= TRUE;								// IZobt@ƃXeVobt@쐬
	param.AutoDepthStencilFormat		= D3DFMT_D24S8;						// Zobt@ƃXeVobt@̃tH[}bg

	// ݂̃fBXvC̃obNobt@tH[}bg擾
	D3DDISPLAYMODE dm;
	HRESULT ret = lpD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT,&dm );	// DEFAULTwŃvC}A_v^I
	if( FAILED(ret) ) {
		MessageBoxW( win.hWnd,L"Direct3D쐬o܂ł",L"G[ɂ",MB_OK|MB_ICONHAND );
		return -1;
	}
	param.BackBufferFormat = dm.Format;										// obNobt@̃tH[}bgRs[

	// Direct3DDevice쐬
	ret = lpD3D->CreateDevice(
		D3DADAPTER_DEFAULT,								// ftHg3DfoCXgp
		D3DDEVTYPE_HAL,									// n[hEFAgp
		win.hWnd,										// EChẼnh
		D3DCREATE_HARDWARE_VERTEXPROCESSING,			// n[hEFA_s(VGADX8ɑΉĂȂꍇSOFTWAREݒ)					
		&param,											// LŐݒ肵\̂̃|C^
		&lpD3DDevice );									// 쐬ꂽfoCX󂯎ϐ̃|C^
	if( FAILED(ret) ) {
		// G[ȂI
		lpD3D->Release();
		MessageBoxW( win.hWnd,L"Direct3DDevice쐬o܂ł",L"G[ɂ",MB_OK | MB_ICONHAND);
		return -1;
	}

	// eNX`t@C쐬
	ret = D3DXCreateTextureFromFileExA(
		lpD3DDevice,			// Direct3DDevicẽ|C^
		"BM.BMP",				// t@C
		D3DX_DEFAULT,			// eNX`̕(摜擾)
		D3DX_DEFAULT,			// eNX`̍(摜擾)
		1,						// ~bv}bveNX`쐬郌x(1Ƃ̃eNX`̂ݍ쐬)
		0,						// _O^[QbgƂ͂Ȃ
		D3DFMT_UNKNOWN,			// eNX`̃tH[}bg摜擾
		D3DPOOL_MANAGED,		// eNX`ĂIɑޔĂ
		D3DX_FILTER_POINT,		// eNX`̕`掞Ɉԋ߂hbggp
		D3DX_FILTER_NONE,		// ~bv}bveNX`̃tB^gpȂ
		0,						// J[L[gpȂ(At@΂g)
		NULL,					// 쐬ꂽeNX`̏ԂȂĂ悢ꍇNULL
		NULL,					// pbgԂȂĂ悢ꍇNULL
		&lpTex );				// 쐬ꂽeNX`󂯎ϐ̃|C^
	if( FAILED(ret) ) {
		// 쐬G[
		lpD3DDevice->Release();
		lpD3D->Release();
		MessageBoxW( win.hWnd,L"eNX`쐬o܂ł",L"G[ɂ",MB_OK|MB_ICONHAND );
		return -1;
	}

	// _̏
	ZeroMemory( &v,sizeof(v) );

	v[0].x		= 160.0f;
	v[0].y		= 120.0f;
	v[0].z		= 0.0f;
	v[0].rhw	= 1.0f;
	v[0].color	= 0xFFFFFFFF;
	v[0].tu		= 0.0f;
	v[0].tv		= 0.0f;

	v[1].x		= 480.0f;
	v[1].y		= 120.0f;
	v[1].z		= 0.0f;
	v[1].rhw	= 1.0f;
	v[1].color	= 0xFFFFFFFF;
	v[1].tu		= 1.0f;
	v[1].tv		= 0.0f;

	v[2].x		= 160.0f;
	v[2].y		= 360.0f;
	v[2].z		= 0.0f;
	v[2].rhw	= 1.0f;
	v[2].color	= 0xFFFFFFFF;
	v[2].tu		= 0.0f;
	v[2].tv		= 1.0f;

	v[3].x		= 480.0f;
	v[3].y		= 360.0f;
	v[3].z		= 0.0f;
	v[3].rhw	= 1.0f;
	v[3].color	= 0xFFFFFFFF;
	v[3].tu		= 1.0f;
	v[3].tv		= 1.0f;

	// wip_̏
	ZeroMemory( &v2,sizeof(v2) );

	v2[0].x		= 0.0f;
	v2[0].y		= 0.0f;
	v2[0].z		= 0.0f;
	v2[0].rhw	= 1.0f;
	v2[0].color	= 0xFFFFFFFF;
	v2[0].tu	= 0.0f;
	v2[0].tv	= 0.0f;

	v2[1].x		= 640.0f;
	v2[1].y		= 0.0f;
	v2[1].z		= 0.0f;
	v2[1].rhw	= 1.0f;
	v2[1].color	= 0xFFFFFFFF;
	v2[1].tu	= 1.0f;
	v2[1].tv	= 0.0f;

	v2[2].x		= 0.0f;
	v2[2].y		= 480.0f;
	v2[2].z		= 0.0f;
	v2[2].rhw	= 1.0f;
	v2[2].color	= 0xFFFFFFFF;
	v2[2].tu	= 0.0f;
	v2[2].tv	= 1.0f;

	v2[3].x		= 640.0f;
	v2[3].y		= 480.0f;
	v2[3].z		= 0.0f;
	v2[3].rhw	= 1.0f;
	v2[3].color	= 0xFFFFFFFF;
	v2[3].tu	= 1.0f;
	v2[3].tv	= 1.0f;

	// Lɂ
	lpD3DDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );

	// ̉摜̍ŃAt@lgp
	lpD3DDevice->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_SRCALPHA );

	// 1ڂ̃eNX`̍@ݒ肷
	lpD3DDevice->SetTextureStageState( 0,D3DTSS_ALPHAOP, D3DTOP_MODULATE );


    // C[v
    MSG msg;
    while(1) {
        if( PeekMessage(&msg,NULL,0,0,PM_REMOVE) ) {	// vÕbZ[W
            if( msg.message==WM_QUIT )
                 break;									// ALT+F4ꂽ烁C𔲂
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }

		// obNobt@̃NA
		lpD3DDevice->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER|D3DCLEAR_STENCIL, D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );

		// V[̊Jn
		lpD3DDevice->BeginScene();

		// eNX`̃Zbg
		lpD3DDevice->SetTexture( 0,lpTex );

		// gp钸_tH[}bg̃Zbg
		lpD3DDevice->SetFVF( D3DFVF_TLVERTEX );

		// wi̕`
		lpD3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, v2, sizeof(D3DTLVERTEX) );

		// _OXe[g̕ύX
		lpD3DDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE );

		// _Xg̕`
		lpD3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, v, sizeof(D3DTLVERTEX) );
 
		// _OXe[g߂
		lpD3DDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );

		// V[̏I
		lpD3DDevice->EndScene();

		// tbvĎۂɉʂɔf
		lpD3DDevice->Present( NULL,NULL,NULL,NULL );

        Sleep(15);										// CPUւ̃EGCg
    }

	// J
	lpTex->Release();
	lpD3DDevice->Release();
	lpD3D->Release();

	win.Delete();
	
	return 0;
}
